<?php



/*



Plugin Name: Brave Minisite



Plugin URI: http://www.braveminisitetemplates.com 



Description: Add minisite TinyMCE buttons to WordPress by BraveMinisiteTemplates.com



Version: 1.0



Author: Lucas Adamski



Author URI: http://www.braveminisitetemplates.com



*/







$custmce_fullpath = get_bloginfo('wpurl').'/wp-content/plugins/braveminisite/';



define('CUSTMCE_FULLPATH', $custmce_fullpath);







function custmce_addbuttons() {



   // Don't bother doing this stuff if the current user lacks permissions



   if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )



     return;



 



   // Add only in Rich Editor mode



   if ( get_user_option('rich_editing') == 'true') {



     add_filter("mce_external_plugins", "add_custmce_tinymce_plugin");

     add_filter('mce_buttons_2', 'register_custmce_button');

     add_filter('mce_buttons_3', 'register_custmce_button2');



   }



}



function register_custmce_button($buttons) {

   array_push($buttons, 'insert_headline1', 'insert_headline2', 'insert_author', 'insert_video', 'insert_testimonial', 'insert_section');

   return $buttons;

}



function register_custmce_button2($buttons) {



   array_push($buttons, 'insert_order', 'insert_signature', 'insert_ps', 'insert_footer', 'insert_fullsalespage', 'insert_advert');



   return $buttons;



}



 



// Load the TinyMCE plugin : editor_plugin.js (wp2.5)



function add_custmce_tinymce_plugin($plugin_array) {



   $plugin_array['insert_custmce'] = CUSTMCE_FULLPATH.'editor_plugin.js';



   return $plugin_array;



}



 



// init process for button control



add_action('init', 'custmce_addbuttons');



